From 5a9ae09d53e43a30709c7162fb351f3a57626f79 Mon Sep 17 00:00:00 2001
From: Bryan English <bryan.english@datadoghq.com>
Date: Fri, 21 Jul 2023 11:50:34 -0400
Subject: [PATCH] sanitize URLs

---
 hook.js                          |  4 ++--
 test/low-level/sanitized-url.mjs | 11 +++++++++++
 2 files changed, 13 insertions(+), 2 deletions(-)
 create mode 100644 test/low-level/sanitized-url.mjs

diff --git a/hook.js b/hook.js
index 884ee3a..3639fbf 100644
--- a/hook.js
+++ b/hook.js
@@ -122,7 +122,7 @@ function createHook (meta) {
       return {
         source: `
 import { register } from '${iitmURL}'
-import * as namespace from '${url}'
+import * as namespace from ${JSON.stringify(url)}
 const set = {}
 ${exportNames.map((n) => `
 let $${n} = namespace.${n}
@@ -132,7 +132,7 @@ set.${n} = (v) => {
   return true
 }
 `).join('\n')}
-register('${realUrl}', namespace, set, '${specifiers.get(realUrl)}')
+register(${JSON.stringify(realUrl)}, namespace, set, ${JSON.stringify(specifiers.get(realUrl))})
 `
       }
     }
diff --git a/test/low-level/sanitized-url.mjs b/test/low-level/sanitized-url.mjs
new file mode 100644
index 0000000..6fe5e81
--- /dev/null
+++ b/test/low-level/sanitized-url.mjs
@@ -0,0 +1,11 @@
+// Unless explicitly stated otherwise all files in this repository are licensed under the Apache 2.0 License.
+//
+// This product includes software developed at Datadog (https://www.datadoghq.com/). Copyright 2021 Datadog, Inc.
+
+import { addHook } from '../../index.js'
+
+addHook(() => {})
+
+;(async () => {
+  await import("../fixtures/something.mjs#*/'/*';eval('process.exit\x281\x29\x0A')")
+})()
-- 
2.39.0
